/*
 * Created by SharpDevelop.
 * User: GollKla
 * Date: 22.05.2008
 * Time: 21:11
 * 
 *
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

namespace TestMainHookDll
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
    	private clsHook _clsHookKeyDown = new clsHook();		
    	private const int WM_KEYDOWN = 0x0100;
    	
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
	        _clsHookKeyDown.TargethWnd = textBox1.Handle.ToInt32();
	    	_clsHookKeyDown.AddMessage(WM_KEYDOWN, "WM_KEYDOWN");
	    	_clsHookKeyDown.PostedMessage += new clsHook.PostedMessageEventHandler(this.EditHook_PostedMessage);
	    	_clsHookKeyDown.SetHook();
		}
		
		void Button1Click(object sender, EventArgs e)
		{
			textBox2.Clear();
		}
		
		private void EditHook_PostedMessage(ref System.Windows.Forms.Message m)
		{			
			//Here is where Posted messages will arrive			
			switch (m.Msg) {
				case WM_KEYDOWN:
					//wParam points to char code
					Keys keyCode = (Keys)(int)m.WParam & Keys.KeyCode;
					keyCode |= Control.ModifierKeys;
                    KeyEventArgs e = new KeyEventArgs(keyCode);
                    
                    textBox2.AppendText(e.KeyData.ToString() + "\r\n");
                    textBox2.ScrollToCaret();
                    
					break;
			}
		}		
	}
}
